<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlaceIdentifier_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlaceIdentifier_V2 extends AbstractStructArrayBase
{
    /**
     * The PlaceIdentifier_V2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlaceIdentifier_V2[]
     */
    public $PlaceIdentifier_V2;
    /**
     * Constructor method for ArrayOfPlaceIdentifier_V2
     * @uses ArrayOfPlaceIdentifier_V2::setPlaceIdentifier_V2()
     * @param \StructType\PlaceIdentifier_V2[] $placeIdentifier_V2
     */
    public function __construct(array $placeIdentifier_V2 = array())
    {
        $this
            ->setPlaceIdentifier_V2($placeIdentifier_V2);
    }
    /**
     * Get PlaceIdentifier_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlaceIdentifier_V2[]|null
     */
    public function getPlaceIdentifier_V2()
    {
        return isset($this->PlaceIdentifier_V2) ? $this->PlaceIdentifier_V2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPlaceIdentifier_V2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlaceIdentifier_V2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePlaceIdentifier_V2ForArrayConstraintsFromSetPlaceIdentifier_V2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPlaceIdentifier_V2PlaceIdentifier_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfPlaceIdentifier_V2PlaceIdentifier_V2Item instanceof \StructType\PlaceIdentifier_V2) {
                $invalidValues[] = is_object($arrayOfPlaceIdentifier_V2PlaceIdentifier_V2Item) ? get_class($arrayOfPlaceIdentifier_V2PlaceIdentifier_V2Item) : sprintf('%s(%s)', gettype($arrayOfPlaceIdentifier_V2PlaceIdentifier_V2Item), var_export($arrayOfPlaceIdentifier_V2PlaceIdentifier_V2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PlaceIdentifier_V2 property can only contain items of type \StructType\PlaceIdentifier_V2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PlaceIdentifier_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceIdentifier_V2[] $placeIdentifier_V2
     * @return \ArrayType\ArrayOfPlaceIdentifier_V2
     */
    public function setPlaceIdentifier_V2(array $placeIdentifier_V2 = array())
    {
        // validation for constraint: array
        if ('' !== ($placeIdentifier_V2ArrayErrorMessage = self::validatePlaceIdentifier_V2ForArrayConstraintsFromSetPlaceIdentifier_V2($placeIdentifier_V2))) {
            throw new \InvalidArgumentException($placeIdentifier_V2ArrayErrorMessage, __LINE__);
        }
        if (is_null($placeIdentifier_V2) || (is_array($placeIdentifier_V2) && empty($placeIdentifier_V2))) {
            unset($this->PlaceIdentifier_V2);
        } else {
            $this->PlaceIdentifier_V2 = $placeIdentifier_V2;
        }
        return $this;
    }
    /**
     * Add item to PlaceIdentifier_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceIdentifier_V2 $item
     * @return \ArrayType\ArrayOfPlaceIdentifier_V2
     */
    public function addToPlaceIdentifier_V2(\StructType\PlaceIdentifier_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlaceIdentifier_V2) {
            throw new \InvalidArgumentException(sprintf('The PlaceIdentifier_V2 property can only contain items of type \StructType\PlaceIdentifier_V2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PlaceIdentifier_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlaceIdentifier_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlaceIdentifier_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlaceIdentifier_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlaceIdentifier_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlaceIdentifier_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlaceIdentifier_V2
     */
    public function getAttributeName()
    {
        return 'PlaceIdentifier_V2';
    }
}
